// merge.c
// LiVES (lives-exe)
// (c) G. Finch 2003
// Released under the GPL 2.0
// see file ../COPYING for licensing details


#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "main.h"
#include "callbacks.h"
#include "merge.h"
#include "support.h"


static gboolean align_start;
static gboolean loop_to_fit;
static gboolean ins_frames;

void
create_merge_dialog (void)
{
  GtkWidget *dialog_vbox12;
  GtkWidget *vbox17;
  GtkWidget *vbox_method;
  GtkWidget *table7;
  GSList *radiobutton21_group = NULL;
  GSList *radiobutton24_group = NULL;
  GtkWidget *hbox17;
  GtkWidget *label76;
  GtkWidget *label62;
  GtkWidget *label63;
  GtkObject *spinbutton40_adj;
  GtkObject *spinbutton41_adj;
  GtkWidget *label64;
  GtkObject *spinbutton42_adj;
  GtkWidget *label65;
  GtkObject *spinbutton43_adj;
  GtkObject *spinbutton44_adj;
  GtkObject *spinbutton45_adj;
  GtkObject *spinbutton_thresh_adj;
  GtkWidget *hbox18;
  GtkWidget *label77;
  GtkWidget *label78;
  GtkObject *spinbutton46_adj;
  GtkWidget *table9;
  GtkWidget *table10;
  GtkWidget *table11;
  GtkWidget *label73;
  GtkWidget *label74;
  GtkWidget *label75;
  GtkWidget *label80;
  GtkWidget *label81;
  GtkWidget *label82;
  GtkWidget *label92;
  GtkWidget *hseparator12;
  GtkWidget *label79;
  GSList *radiobutton23_group = NULL;
  GtkObject *spinbutton49_adj;
  GtkWidget *dialog_action_area12;
  GtkWidget *cancelbutton10;
  GtkWidget *okbutton9;
  GtkWidget *frame_in_frame;
  GtkWidget *frame_method;

  gint maxextent;
  gint cb_frames=clipboard->frames;
  gchar *txt;

  merge_opts=(_merge_opts*)(g_malloc(sizeof(_merge_opts)));

  merge_opts->merge_dialog = gtk_dialog_new ();
  gtk_container_set_border_width (GTK_CONTAINER (merge_opts->merge_dialog), 10);
  gtk_window_set_title (GTK_WINDOW (merge_opts->merge_dialog), _("LiVES: - Merge"));
  gtk_window_set_position (GTK_WINDOW (merge_opts->merge_dialog), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (merge_opts->merge_dialog), TRUE);
  gtk_widget_set_size_request (merge_opts->merge_dialog, 720, -1);
  gtk_dialog_set_has_separator(GTK_DIALOG(merge_opts->merge_dialog),FALSE);

  if (palette->style&STYLE_3||palette->style==STYLE_PLAIN) {
    gtk_widget_modify_bg (merge_opts->merge_dialog, GTK_STATE_NORMAL, &palette->normal_back);
  }
  else {
    gtk_widget_modify_bg (merge_opts->merge_dialog, GTK_STATE_NORMAL, &palette->menu_and_bars);
  }

  gtk_window_set_transient_for(GTK_WINDOW(merge_opts->merge_dialog),GTK_WINDOW(mainw->LiVES));

  dialog_vbox12 = GTK_DIALOG (merge_opts->merge_dialog)->vbox;
  gtk_widget_show (dialog_vbox12);

  vbox17 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox17);
  gtk_box_pack_start (GTK_BOX (dialog_vbox12), vbox17, TRUE, TRUE, 0);

  hbox17 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox17);
  gtk_box_pack_start (GTK_BOX (vbox17), hbox17, FALSE, FALSE, 19);

  txt=g_strdup_printf("Merge Clipboard [ %d Frames ]       With Selection [ %d Frames ]",clipboard->frames,cfile->end-cfile->start+1);
  if (prefs->ins_resample==TRUE&&clipboard->fps!=cfile->fps) {
    if ((cb_frames=(gint) (clipboard->frames/clipboard->fps*cfile->fps+.49999))<1) cb_frames=1;
    if (!(cb_frames==clipboard->frames)) {
      g_free(txt);
      txt=g_strdup_printf("Merge Clipboard [ %d Frames (resampled) ]       With Selection [ %d Frames ]",cb_frames,cfile->end-cfile->start+1);
    }
  }

  label76 = gtk_label_new (txt);
  g_free(txt);
  gtk_widget_show (label76);
  gtk_box_pack_start (GTK_BOX (hbox17), label76, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label76), GTK_JUSTIFY_LEFT);
  if (palette->style&STYLE_3||palette->style==STYLE_PLAIN) {
    gtk_widget_modify_fg (label76, GTK_STATE_NORMAL, &palette->normal_fore);
  }
  label74 = gtk_label_new ("");
  gtk_widget_show (label74);
  gtk_box_pack_start (GTK_BOX (hbox17), label74, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label74), GTK_JUSTIFY_LEFT);

  merge_opts->align_start = gtk_radio_button_new_with_mnemonic (NULL, _("Align _Starts"));
  gtk_widget_show (merge_opts->align_start);
  gtk_box_pack_start (GTK_BOX (hbox17), merge_opts->align_start, TRUE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (merge_opts->align_start), radiobutton21_group);
  radiobutton21_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (merge_opts->align_start));

  label75 = gtk_label_new ("");
  gtk_widget_show (label75);
  gtk_box_pack_start (GTK_BOX (hbox17), label75, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label75), GTK_JUSTIFY_LEFT);

  merge_opts->align_end = gtk_radio_button_new_with_mnemonic (NULL, _("Align _Ends"));
  gtk_widget_show (merge_opts->align_end);
  gtk_box_pack_start (GTK_BOX (hbox17), merge_opts->align_end, TRUE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (merge_opts->align_end), radiobutton21_group);
  radiobutton21_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (merge_opts->align_end));
  if (palette->style&STYLE_3||palette->style==STYLE_PLAIN) {
    gtk_widget_modify_fg (merge_opts->align_end, GTK_STATE_NORMAL, &palette->normal_fore);
  }

  hbox18 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox18);
  gtk_box_pack_start (GTK_BOX (vbox17), hbox18, FALSE, TRUE, 22);

  spinbutton46_adj = gtk_adjustment_new (1, 1, (gint)((cfile->end-cfile->start+1)/cb_frames), 1, 10, 10);
  merge_opts->spinbutton_loops = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton46_adj), 1, 0);
  merge_opts->ins_frame_button = gtk_radio_button_new_with_mnemonic (NULL, _("_Insert Frames"));
  merge_opts->drop_frame_button = gtk_radio_button_new_with_mnemonic (NULL, _("_Drop Frames"));
  merge_opts->fit_button = gtk_check_button_new_with_mnemonic ("_Loop Clipboard to Fit Selection");

  if ((cfile->end-cfile->start+1)<cb_frames) {
    // hide loop controls if selection is smaller than clipboard
    label77 = gtk_label_new (_("What to do with extra clipboard frames -"));
    gtk_widget_show (label77);
    gtk_box_pack_start (GTK_BOX (hbox18), label77, FALSE, FALSE, 0);
    gtk_label_set_justify (GTK_LABEL (label77), GTK_JUSTIFY_LEFT);
    if (palette->style&STYLE_3||palette->style==STYLE_PLAIN) {
      gtk_widget_modify_fg (label77, GTK_STATE_NORMAL, &palette->normal_fore);
    }

    gtk_widget_show (merge_opts->ins_frame_button);
    gtk_box_pack_start (GTK_BOX (hbox18), merge_opts->ins_frame_button, TRUE, FALSE, 0);
    gtk_radio_button_set_group (GTK_RADIO_BUTTON (merge_opts->ins_frame_button), radiobutton24_group);
    radiobutton24_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (merge_opts->ins_frame_button));

    gtk_widget_show (merge_opts->drop_frame_button);
    gtk_box_pack_start (GTK_BOX (hbox18), merge_opts->drop_frame_button, TRUE, FALSE, 0);
    gtk_radio_button_set_group (GTK_RADIO_BUTTON (merge_opts->drop_frame_button), radiobutton24_group);
    radiobutton24_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (merge_opts->drop_frame_button));
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(merge_opts->drop_frame_button),TRUE);
  }
  else if ((cfile->end-cfile->start+1)>cb_frames) {
    
    label77 = gtk_label_new (_("Number of Times to Loop Clipboard"));
    gtk_widget_show (label77);
    gtk_box_pack_start (GTK_BOX (hbox18), label77, FALSE, FALSE, 0);
    gtk_label_set_justify (GTK_LABEL (label77), GTK_JUSTIFY_LEFT);
    if (palette->style&STYLE_3||palette->style==STYLE_PLAIN) {
      gtk_widget_modify_fg (label77, GTK_STATE_NORMAL, &palette->normal_fore);
    }
    gtk_widget_show (merge_opts->spinbutton_loops);
    gtk_box_pack_start (GTK_BOX (hbox18), merge_opts->spinbutton_loops, TRUE, FALSE, 0);

    gtk_widget_show (merge_opts->fit_button);
    gtk_box_pack_start (GTK_BOX (hbox18), merge_opts->fit_button, FALSE, FALSE, 0);
  }
  else {
    gtk_widget_hide(hbox18);
  }

  frame_in_frame=gtk_frame_new(NULL);
  gtk_widget_show(frame_in_frame);

  if (palette->style&STYLE_3||palette->style==STYLE_PLAIN) {
    gtk_widget_modify_bg (frame_in_frame, GTK_STATE_NORMAL, &palette->normal_back);
  }
  else {
    gtk_widget_modify_bg (frame_in_frame, GTK_STATE_NORMAL, &palette->menu_and_bars);
  }

  label78 = gtk_label_new (_("Frame in Frame Position"));
  gtk_widget_show (label78);
  if (palette->style&STYLE_3||palette->style==STYLE_PLAIN) {
    gtk_widget_modify_fg (label78, GTK_STATE_NORMAL, &palette->normal_fore);
  }

  gtk_frame_set_label_widget (GTK_FRAME (frame_in_frame), label78);
  gtk_label_set_justify (GTK_LABEL (label78), GTK_JUSTIFY_LEFT);

  gtk_box_pack_start (GTK_BOX (vbox17), frame_in_frame, FALSE, FALSE, 0);

  table7 = gtk_table_new (2, 5, FALSE);
  gtk_container_set_border_width (GTK_CONTAINER(table7), 10);

  gtk_widget_show (table7);
  gtk_container_add (GTK_CONTAINER (frame_in_frame), table7);
  gtk_table_set_row_spacings (GTK_TABLE (table7), 32);

  label62 = gtk_label_new ("    Width    ");
  gtk_widget_show (label62);
  gtk_table_attach (GTK_TABLE (table7), label62, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (label62), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label62), 0, 0.5);
  if (palette->style&STYLE_3||palette->style==STYLE_PLAIN) {
    gtk_widget_modify_fg (label62, GTK_STATE_NORMAL, &palette->normal_fore);
  }

  spinbutton40_adj = gtk_adjustment_new (mainw->fx5_val, 1, cfile->hsize, 1, 10, 100);
  merge_opts->spinbutton_width = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton40_adj), 1, 0);
  gtk_widget_show (merge_opts->spinbutton_width);
  gtk_table_attach (GTK_TABLE (table7), merge_opts->spinbutton_width, 2, 3, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (merge_opts->spinbutton_width), TRUE);

  spinbutton41_adj = gtk_adjustment_new (mainw->fx6_val, 1, cfile->vsize, 1, 10, 100);
  merge_opts->spinbutton_height = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton41_adj), 1, 0);
  gtk_widget_show (merge_opts->spinbutton_height);
  gtk_table_attach (GTK_TABLE (table7), merge_opts->spinbutton_height, 4, 5, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (merge_opts->spinbutton_height), TRUE);

  label64 = gtk_label_new (_("   X offset"));
  gtk_widget_show (label64);
  gtk_table_attach (GTK_TABLE (table7), label64, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (label64), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label64), 0, 0.5);
  if (palette->style&STYLE_3||palette->style==STYLE_PLAIN) {
    gtk_widget_modify_fg (label64, GTK_STATE_NORMAL, &palette->normal_fore);
  }
  spinbutton42_adj = gtk_adjustment_new (0, 0, 0, 1, 0, 0);
  merge_opts->spinbutton_hoffs = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton42_adj), 1, 0);
  gtk_widget_show (merge_opts->spinbutton_hoffs);
  gtk_table_attach (GTK_TABLE (table7), merge_opts->spinbutton_hoffs, 2, 3, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (merge_opts->spinbutton_hoffs), TRUE);

  spinbutton43_adj = gtk_adjustment_new (0, 0, 0, 1, 0, 0);
  merge_opts->spinbutton_voffs = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton43_adj), 1, 0);
  gtk_widget_show (merge_opts->spinbutton_voffs);
  gtk_table_attach (GTK_TABLE (table7), merge_opts->spinbutton_voffs, 4, 5, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (merge_opts->spinbutton_voffs), TRUE);

  label73 = gtk_label_new ("");
  gtk_widget_show (label73);
  gtk_table_attach (GTK_TABLE (table7), label73, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (label73), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label73), 0, 0.5);

  merge_opts->aspect_checkbutton = gtk_check_button_new_with_mnemonic (_("Maintain _Aspect"));
  gtk_widget_show (merge_opts->aspect_checkbutton);
  gtk_table_attach (GTK_TABLE (table7), merge_opts->aspect_checkbutton, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (merge_opts->aspect_checkbutton), TRUE);

  label65 = gtk_label_new (_("   Y Offset   "));
  gtk_widget_show (label65);
  gtk_table_attach (GTK_TABLE (table7), label65, 3, 4, 1, 2,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 58, 0);
  gtk_label_set_justify (GTK_LABEL (label65), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label65), 0, 0.5);
  if (palette->style&STYLE_3||palette->style==STYLE_PLAIN) {
    gtk_widget_modify_fg (label65, GTK_STATE_NORMAL, &palette->normal_fore);
  }
  label63 = gtk_label_new (_("    Height   "));
  gtk_widget_show (label63);
  gtk_table_attach (GTK_TABLE (table7), label63, 3, 4, 0, 1,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 58, 0);
  gtk_label_set_justify (GTK_LABEL (label63), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label63), 0, 0.5);
  if (palette->style&STYLE_3||palette->style==STYLE_PLAIN) {
    gtk_widget_modify_fg (label63, GTK_STATE_NORMAL, &palette->normal_fore);
  }
  merge_opts->centred_checkbutton = gtk_check_button_new_with_mnemonic (_("Keep in _Centre"));
  gtk_widget_show (merge_opts->centred_checkbutton);
  gtk_table_attach (GTK_TABLE (table7), merge_opts->centred_checkbutton, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (merge_opts->centred_checkbutton), TRUE);

  frame_method=gtk_frame_new(NULL);
  gtk_widget_show(frame_method);

  if (palette->style&STYLE_3||palette->style==STYLE_PLAIN) {
    gtk_widget_modify_bg (frame_method, GTK_STATE_NORMAL, &palette->normal_back);
  }
  else {
    gtk_widget_modify_bg (frame_method, GTK_STATE_NORMAL, &palette->menu_and_bars);
  }

  label79 = gtk_label_new (_("Merge Method"));
  gtk_widget_show (label79);
  if (palette->style&STYLE_3||palette->style==STYLE_PLAIN) {
    gtk_widget_modify_fg (label79, GTK_STATE_NORMAL, &palette->normal_fore);
  }

  gtk_frame_set_label_widget (GTK_FRAME (frame_method), label79);
  gtk_label_set_justify (GTK_LABEL (label79), GTK_JUSTIFY_LEFT);
  gtk_box_pack_start (GTK_BOX (vbox17), frame_method, TRUE, TRUE, 16);

  vbox_method = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox_method);
  gtk_container_add (GTK_CONTAINER (frame_method), vbox_method);

  table9 = gtk_table_new (2, 7, FALSE);
  gtk_widget_show (table9);
  gtk_container_set_border_width (GTK_CONTAINER(table9), 10);

  gtk_table_set_row_spacings (GTK_TABLE (table9), 32);
  gtk_box_pack_start (GTK_BOX (vbox_method), table9, TRUE, TRUE, 0);

  merge_opts->fade_button = gtk_radio_button_new_with_mnemonic (NULL, _("_Fade / Unfade             "));
  gtk_widget_show (merge_opts->fade_button);
  gtk_table_attach (GTK_TABLE (table9), merge_opts->fade_button, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (merge_opts->fade_button), radiobutton23_group);
  radiobutton23_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (merge_opts->fade_button));

  label80 = gtk_label_new (_("    Start %   "));
  gtk_widget_show (label80);
  gtk_table_attach (GTK_TABLE (table9), label80, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (label80), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label80), 0, 0.5);
  if (palette->style&STYLE_3||palette->style==STYLE_PLAIN) {
    gtk_widget_modify_fg (label80, GTK_STATE_NORMAL, &palette->normal_fore);
  }
  label81 = gtk_label_new (_("     Step %   "));
  gtk_widget_show (label81);
  gtk_table_attach (GTK_TABLE (table9), label81, 3, 4, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (label81), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label81), 0, 0.5);
  if (palette->style&STYLE_3||palette->style==STYLE_PLAIN) {
    gtk_widget_modify_fg (label81, GTK_STATE_NORMAL, &palette->normal_fore);
  }
  label82 = gtk_label_new (_(" Min/Max %    "));
  gtk_widget_show (label82);
  gtk_table_attach (GTK_TABLE (table9), label82, 5, 6, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (label82), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label82), 0, 0.5);
  if (palette->style&STYLE_3||palette->style==STYLE_PLAIN) {
    gtk_widget_modify_fg (label82, GTK_STATE_NORMAL, &palette->normal_fore);
  }
  if ((maxextent=cfile->end-cfile->start+1)>cb_frames) {
    maxextent=cb_frames;
    spinbutton45_adj = gtk_adjustment_new (0., -100, 100, .1, 1, 10);
    spinbutton44_adj = gtk_adjustment_new (50, 0, 100, 1, 10, 10);
    spinbutton49_adj = gtk_adjustment_new (50, 0, 100, 1, 0, 0);
  }
  else {
    maxextent=cfile->end-cfile->start+1;
    spinbutton45_adj = gtk_adjustment_new (100./maxextent, -100, 100, .1, 1, 10);
    spinbutton44_adj = gtk_adjustment_new (0, 0, 100, 1, 10, 10);
    spinbutton49_adj = gtk_adjustment_new (100, 0, 100, 1, 0, 0);
  }
  
  merge_opts->spinbutton_pcstart = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton44_adj), 1, 0);
  gtk_widget_show (merge_opts->spinbutton_pcstart);
  gtk_table_attach (GTK_TABLE (table9), merge_opts->spinbutton_pcstart, 2, 3, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (merge_opts->spinbutton_pcstart), TRUE);

  merge_opts->spinbutton_pcstep = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton45_adj), 1, 1);
  gtk_widget_show (merge_opts->spinbutton_pcstep);
  gtk_table_attach (GTK_TABLE (table9), merge_opts->spinbutton_pcstep, 4, 5, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (merge_opts->spinbutton_pcstep), TRUE);

  merge_opts->spinbutton_pcend = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton49_adj), 1, 0);
  gtk_widget_show (merge_opts->spinbutton_pcend);
  gtk_table_attach (GTK_TABLE (table9), merge_opts->spinbutton_pcend, 6, 7, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (merge_opts->spinbutton_pcend), TRUE);

 
  hseparator12 = gtk_hseparator_new ();
  gtk_widget_show (hseparator12);
  gtk_box_pack_start (GTK_BOX (vbox_method), hseparator12, TRUE, TRUE, 0);

  table10 = gtk_table_new (1, 7, FALSE);
  gtk_widget_show (table10);
  gtk_box_pack_start (GTK_BOX (vbox_method), table10, TRUE, TRUE, 0);
  gtk_table_set_row_spacings (GTK_TABLE (table10), 32);
  gtk_container_set_border_width (GTK_CONTAINER(table10), 10);

  merge_opts->transf_button = gtk_radio_button_new_with_mnemonic (NULL, _("Transparent _Over"));
  gtk_widget_show (merge_opts->transf_button);
  gtk_table_attach (GTK_TABLE (table10), merge_opts->transf_button, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (merge_opts->transf_button), radiobutton23_group);
  radiobutton23_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (merge_opts->transf_button));

  label92 = gtk_label_new (" Threshold [0 = black only, 65535 = all transparent]");
  gtk_widget_show (label92);
  gtk_table_attach (GTK_TABLE (table10), label92, 2, 3, 0, 1,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (label92), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label92), 0, 0.5);
  if (palette->style&STYLE_3||palette->style==STYLE_PLAIN) {
    gtk_widget_modify_fg (label92, GTK_STATE_NORMAL, &palette->normal_fore);
  }
  spinbutton_thresh_adj = gtk_adjustment_new (8000, 0, 65535, 100, 1000, 10000);
  merge_opts->spinbutton_thresh = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_thresh_adj), 1, 0);
  gtk_widget_show (merge_opts->spinbutton_thresh);
  gtk_table_attach (GTK_TABLE (table10), merge_opts->spinbutton_thresh, 4, 5, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (merge_opts->spinbutton_thresh), TRUE);
  gtk_widget_set_size_request (merge_opts->spinbutton_thresh, 60, -1);


  table11 = gtk_table_new (1, 7, FALSE);
  gtk_widget_show (table11);
  gtk_box_pack_start (GTK_BOX (vbox_method), table11, TRUE, TRUE, 0);
  gtk_table_set_row_spacings (GTK_TABLE (table11), 32);
  gtk_container_set_border_width (GTK_CONTAINER(table11), 10);

  merge_opts->transb_button = gtk_radio_button_new_with_mnemonic (NULL, _("Transparent _Under"));
  gtk_widget_show (merge_opts->transb_button);
  gtk_table_attach (GTK_TABLE (table11), merge_opts->transb_button, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (merge_opts->transb_button), radiobutton23_group);
  radiobutton23_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (merge_opts->transb_button));
 
  merge_opts->white_checkbutton = gtk_check_button_new_with_mnemonic (_("Make _White Transparent Instead of Black"));
  gtk_widget_show (merge_opts->white_checkbutton);
  gtk_table_attach (GTK_TABLE (table11), merge_opts->white_checkbutton, 2, 3, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (merge_opts->white_checkbutton), FALSE);

  dialog_action_area12 = GTK_DIALOG (merge_opts->merge_dialog)->action_area;
  gtk_widget_show (dialog_action_area12);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area12), GTK_BUTTONBOX_END);

  cancelbutton10 = gtk_button_new_from_stock ("gtk-cancel");
  gtk_widget_show (cancelbutton10);
  gtk_dialog_add_action_widget (GTK_DIALOG (merge_opts->merge_dialog), cancelbutton10, GTK_RESPONSE_CANCEL);
  GTK_WIDGET_SET_FLAGS (cancelbutton10, GTK_CAN_DEFAULT);

  okbutton9 = gtk_button_new_from_stock ("gtk-ok");
  gtk_widget_show (okbutton9);
  gtk_dialog_add_action_widget (GTK_DIALOG (merge_opts->merge_dialog), okbutton9, GTK_RESPONSE_OK);
  GTK_WIDGET_SET_FLAGS (okbutton9, GTK_CAN_DEFAULT);
 



  g_signal_connect (GTK_OBJECT (cancelbutton10), "clicked",
                      G_CALLBACK (on_merge_cancel_clicked),
                      NULL);

  g_signal_connect (GTK_OBJECT (okbutton9), "clicked",
                      G_CALLBACK (on_merge_ok_clicked),
                      NULL);

  g_signal_connect_after (GTK_OBJECT (merge_opts->spinbutton_pcstart), "value_changed",
                      G_CALLBACK (on_mspin1_value_changed),
                      NULL);

  g_signal_connect_after (GTK_OBJECT (merge_opts->spinbutton_pcstep), "value_changed",
                      G_CALLBACK (on_mspin2_value_changed),
                      NULL);

  g_signal_connect_after (GTK_OBJECT (merge_opts->spinbutton_hoffs), "value_changed",
                      G_CALLBACK (on_spin_value_changed),
                      GINT_TO_POINTER (3));

  g_signal_connect_after (GTK_OBJECT (merge_opts->spinbutton_voffs), "value_changed",
                      G_CALLBACK (on_spin_value_changed),
                      GINT_TO_POINTER (4));

  g_signal_connect_after (GTK_OBJECT (merge_opts->spinbutton_width), "value_changed",
                      G_CALLBACK (on_merge_hsize_value_changed),
                      NULL);

  g_signal_connect_after (GTK_OBJECT (merge_opts->spinbutton_height), "value_changed",
                      G_CALLBACK (on_merge_vsize_value_changed),
                      NULL);

  g_signal_connect (GTK_OBJECT (merge_opts->aspect_checkbutton), "toggled",
		    G_CALLBACK (on_boolean_toggled),
		    GINT_TO_POINTER (1));

  g_signal_connect (GTK_OBJECT (merge_opts->centred_checkbutton), "toggled",
		    G_CALLBACK (on_merge_centred_toggled),
		    NULL);

  g_signal_connect (GTK_OBJECT (merge_opts->align_start), "toggled",
		    G_CALLBACK (on_align_start_end_toggled),
		    NULL);

  if ((cfile->end-cfile->start+1)>cb_frames) {
    g_signal_connect (GTK_OBJECT (merge_opts->fit_button), "toggled",
		      G_CALLBACK (on_fit_toggled),
		      NULL);
  }
  else if ((cfile->end-cfile->start+1)<cb_frames) {
    merge_opts->ins_frame_function=g_signal_connect (GTK_OBJECT (merge_opts->ins_frame_button), "toggled",
						    G_CALLBACK (on_ins_frames_toggled),
						    NULL);
  }
}



void
on_merge_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  gint maxextent;
  gint cb_frames=clipboard->frames;


  align_start=TRUE;
  loop_to_fit=FALSE;
  ins_frames=FALSE;

  if (prefs->ins_resample==TRUE&&clipboard->fps!=cfile->fps) {
    if ((cb_frames=(gint) (clipboard->frames/clipboard->fps*cfile->fps+.49999))<1) cb_frames=1;
  }
  
  if ((maxextent=cfile->end-cfile->start+1)>cb_frames) {
    maxextent=cb_frames;
    mainw->fx1_val=50;
    mainw->fx2_val=0.;
  }
  else {
    maxextent=cfile->end-cfile->start+1;
    mainw->fx1_val=0.;
    mainw->fx2_val=100./maxextent;
  }

  // width and height for f-in-f
  mainw->fx5_val=clipboard->hsize;
  mainw->fx6_val=clipboard->vsize;

  // centred
  mainw->fx1_bool=TRUE;

  // aspect ratio
  mainw->fx2_bool=TRUE;

  if (clipboard->hsize>cfile->hsize) {
    mainw->fx6_val=(gint)(cfile->vsize*cfile->hsize/clipboard->hsize);
    mainw->fx5_val=cfile->hsize;
  }

  if (clipboard->vsize>cfile->vsize) {
    mainw->fx5_val=(gint)(cfile->hsize*cfile->vsize/clipboard->vsize);
    mainw->fx6_val=cfile->vsize;
  }

  // has the user touched the fade controls ?
  mainw->fx4_bool=FALSE;

  create_merge_dialog();
  gtk_widget_show (merge_opts->merge_dialog);

  // offsets
  mainw->fx3_val=0;
  mainw->fx4_val=0;

  // make offsets centred
  if (mainw->fx1_bool==TRUE) {
    on_merge_hsize_value_changed (GTK_SPIN_BUTTON (merge_opts->spinbutton_width),NULL);
    on_merge_vsize_value_changed (GTK_SPIN_BUTTON (merge_opts->spinbutton_height),NULL);
  }
}



void
on_merge_cancel_clicked                   (GtkButton       *button,
					   gpointer         user_data)
{
 gtk_widget_destroy(merge_opts->merge_dialog);
 while (g_main_context_iteration (NULL,FALSE));
 g_free(merge_opts);

}





void
on_merge_ok_clicked                   (GtkButton       *button,
				       gpointer         user_data)
{
  gchar *com;
  gchar *msg;
  gint start,end;

  gint pc_start=100;
  gint pc_end=100;
  gint threshold=100000;
  gdouble pc_step=0.;
  gint cb_start=1;
  gboolean cb_video_change=FALSE;
  gint current_file=mainw->current_file;
  gint old_frames=clipboard->frames;

  gint pcend=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(merge_opts->spinbutton_pcend));
  // save original values in case we cancel
  gint oundo_start=cfile->undo_start;
  gint oundo_end=cfile->undo_end;

  gint cb_end,excess_frames;

  gint times_to_loop=1;
  gboolean trans_white=gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(merge_opts->white_checkbutton));

  if (cfile->fps!=clipboard->fps) {
    if (do_clipboard_fps_warning()==FALSE) {
      gtk_widget_destroy(merge_opts->merge_dialog);
      while (g_main_context_iteration(NULL,FALSE));
      g_free(merge_opts);
      return;
    }
  }

  if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(merge_opts->fade_button))==TRUE) {
    pc_start=mainw->fx1_val;
    pc_step=mainw->fx2_val;
    pc_end=pcend;
  }
  else if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(merge_opts->transf_button))==TRUE) {
    threshold=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(merge_opts->spinbutton_thresh));
  }
  else if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(merge_opts->transb_button))==TRUE) {
    threshold=-gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(merge_opts->spinbutton_thresh))-1;
  }
  times_to_loop=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(merge_opts->spinbutton_loops));

  gtk_widget_destroy(merge_opts->merge_dialog);
  while (g_main_context_iteration(NULL,FALSE));
  g_free(merge_opts);

  // if pref is set, resample clipboard video
  if (prefs->ins_resample==TRUE&&cfile->fps!=clipboard->fps) {
    cb_video_change=TRUE;
    clipboard->undo1_dbl=cfile->fps;
    mainw->current_file=0;
    on_resample_vid_ok(NULL,NULL);
    switch_to_file (0,current_file);
  }

  if ((cfile->end-cfile->start+1)<=clipboard->frames) {
    times_to_loop=1;
  }

  msg=g_strdup_printf("Merging selection with clipboard...");
  d_print(msg);
  g_free(msg);

  excess_frames=clipboard->frames-(cfile->end-cfile->start+1);
  if (excess_frames<0) excess_frames=0;

  cfile->insert_start=0;
  cfile->insert_end=0;

  cfile->redoable=FALSE;
  gtk_widget_set_sensitive(mainw->redo,FALSE);

  mainw->fx2_bool=FALSE;

  // dummy values - used for 'fit to audio' in insert
  mainw->fx1_bool=FALSE;
  mainw->fx1_val=1;  // times to insert

  // insert pre-frames
  if (align_start==FALSE&&excess_frames>0&&ins_frames==TRUE) {
    mainw->insert_after=FALSE;
    msg=g_strdup_printf("inserting %d extra frame(s) before merge\n",excess_frames);
    d_print(msg);
    g_free(msg);
  
    // fx1_start and fx2_start indicate the clipboard start/end values, fx2_bool is insert_with_audio
    mainw->fx1_start=1;
    mainw->fx2_start=excess_frames;
    mainw->fx2_bool=FALSE;
    on_insert_activate(NULL,NULL);
  }

  // these should be the original values, maybe shifted if frames were inserted
  
  // now the merge section
  mainw->effects_paused=FALSE;

  // There are 6 possibilities:

  //               align starts                                       align ends
  //
  //               cb_start   cb_end                                 cb_start     cb_end
  // cb <= sel        1       cb_frames*ttl                            1          cb_frames*ttl
  // cb > sel         1       end-start+1                              excess_frames          cb_frames
  // l2f              1       end-start+1                              1          end-start+1


  // number of frames to merge, must be <= selection length
  if (loop_to_fit==FALSE&&align_start==TRUE) { //loop_to_fit_audio
    cb_end=(clipboard->frames-excess_frames)*times_to_loop;
  }
  else {
    cb_end=cfile->end-cfile->start+1;
  } 

  // here we use undo_start and undo_end to mark the merged section,
  // insert_start and insert_end to mark the inserted section (if any)
  if (align_start==TRUE) {
    cfile->undo_start=cfile->start;
    cfile->undo_end=cfile->start+(cb_end*times_to_loop)-1;
  }
  else {
    cfile->undo_start=cfile->end-(cb_end*times_to_loop)+1;
    cfile->undo_end=cfile->end;
    cb_start=excess_frames+1;
    if (loop_to_fit==TRUE) {
      // make sure last frames are lined up
      cb_start-=cb_end;
      cb_end=(int)((cb_end+clipboard->frames-1)/clipboard->frames)*clipboard->frames;
      cb_start+=cb_end;
    }
  }

  cfile->progress_end=cb_end;
  cfile->progress_start=cb_start;

  // do the actual merge
  com=g_strdup_printf("smogrify merge_frames %s %d %d %d %s %d %d %d %d %d %d %d %d %d %.2f %d",cfile->handle,cfile->undo_start,cb_start,cb_end,clipboard->handle,(int)mainw->fx6_val,(int)mainw->fx5_val,cfile->vsize,cfile->hsize,(int)mainw->fx3_val,(int)mainw->fx4_val,threshold,trans_white,pc_start,pc_step,pc_end);

  unlink(cfile->info_file);

  //cfile->progress_start=1;
  
  system(com);
  g_free(com);
  
  cfile->merging=TRUE;
  if (!(do_progress_dialog(TRUE,TRUE,"Merging"))) {
    // cancelled
    cfile->merging=FALSE;
    // delete pre-inserted frames
      if (align_start==FALSE&&excess_frames>0) {
	start=cfile->start;
	end=cfile->end;
	cfile->start=cfile->insert_start;
	cfile->end=cfile->insert_end;
	on_delete_activate(NULL,NULL);
	// reset to original values
	cfile->start=start;
	cfile->end=end;
      }
      
      cfile->undo_start=oundo_start;
      cfile->undo_end=oundo_end;
      cfile->insert_start=cfile->insert_end=0;

      if (cb_video_change==TRUE) {
	clipboard->old_frames=old_frames;
	mainw->current_file=0;
	on_undo_activate(NULL,NULL);
	switch_to_file(0,current_file);
      }
      set_undoable (NULL, FALSE);

      if (align_start==FALSE&&excess_frames>0) {
	// we've added and now deleted frames, we need to redraw everything...
	cfile->start-=excess_frames;
	cfile->end-=excess_frames;
	switch_to_file(mainw->current_file,mainw->current_file);
      }
      else {
	sensitize();
	get_play_times();
      }
      return;
  }

  cfile->merging=FALSE;

  // insert any post frames
  if (align_start==TRUE&&excess_frames>0&&ins_frames==TRUE) {
    mainw->insert_after=TRUE;
    msg=g_strdup_printf("now inserting %d extra frame(s)\n",excess_frames);
    d_print(msg);
    g_free(msg);
    
      
    // fx1_start and fx2_start hold the clipboard start/end values
    mainw->fx1_start=clipboard->frames-excess_frames+1;
    mainw->fx2_start=clipboard->frames;

    on_insert_activate(NULL,GINT_TO_POINTER (1));
  }
  
  if (excess_frames==0||ins_frames==FALSE) {
    d_print("done\n");
  }
  else {
    d_print("Merge done\n");
  }
  
  if (cb_video_change==TRUE) {
    clipboard->old_frames=old_frames;
    mainw->current_file=0;
    on_undo_activate(NULL,NULL);
    mainw->current_file=current_file;
  }
  
  cfile->undo_action=UNDO_MERGE;
  set_undoable ("Merge",TRUE);
  
  if (cfile->insert_start==0) {
    cfile->insert_start=cfile->undo_start;
    cfile->insert_end=cfile->undo_end;
  }
  if (cfile->undo_end>cfile->insert_end) {
    cfile->insert_end=cfile->undo_end;
  }
  if (cfile->undo_start<cfile->insert_start) {
    cfile->insert_start=cfile->undo_start;
  }
  
  cfile->changed=TRUE;
  switch_to_file (mainw->current_file,mainw->current_file);
}



void
on_merge_hsize_value_changed           (GtkSpinButton   *spinbutton,
                                        gpointer         user_data)
{
  gboolean ofx1_bool=mainw->fx1_bool;

  mainw->fx5_val=gtk_spin_button_get_value(GTK_SPIN_BUTTON(spinbutton));

  gtk_spin_button_set_range(GTK_SPIN_BUTTON(merge_opts->spinbutton_hoffs),0,cfile->hsize-mainw->fx5_val);

  //centred
  if (mainw->fx2_bool==TRUE) {
  gtk_spin_button_set_value(GTK_SPIN_BUTTON(merge_opts->spinbutton_hoffs),(gint)(cfile->hsize-mainw->fx5_val)/2);
  }

  if (mainw->fx1_bool==TRUE) {
    mainw->fx6_val=mainw->fx5_val*clipboard->vsize/clipboard->hsize;
    mainw->fx1_bool=FALSE;
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(merge_opts->spinbutton_height),mainw->fx6_val);
    mainw->fx1_bool=ofx1_bool;
  }
}


void
on_merge_vsize_value_changed           (GtkSpinButton   *spinbutton,
                                        gpointer         user_data)
{
  gboolean ofx1_bool=mainw->fx1_bool;

  mainw->fx6_val=gtk_spin_button_get_value(GTK_SPIN_BUTTON(spinbutton));

  gtk_spin_button_set_range(GTK_SPIN_BUTTON(merge_opts->spinbutton_voffs),0,cfile->vsize-mainw->fx6_val);

  //centred
  if (mainw->fx2_bool==TRUE) {
  gtk_spin_button_set_value(GTK_SPIN_BUTTON(merge_opts->spinbutton_voffs),(gint)(cfile->vsize-mainw->fx6_val)/2);
  }

  if (mainw->fx1_bool==TRUE) {
    mainw->fx5_val=mainw->fx6_val*clipboard->hsize/clipboard->vsize;
    mainw->fx1_bool=FALSE;
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(merge_opts->spinbutton_width),mainw->fx5_val);
    mainw->fx1_bool=ofx1_bool;
  }
}



void
on_merge_centred_toggled        (GtkToggleButton *togglebutton,
				 gpointer         user_data)
{
  mainw->fx2_bool=!mainw->fx2_bool;
  
  if (mainw->fx2_bool==TRUE) {
  gtk_spin_button_set_value(GTK_SPIN_BUTTON(merge_opts->spinbutton_hoffs),(gint)(cfile->hsize-mainw->fx5_val)/2);
  gtk_spin_button_set_value(GTK_SPIN_BUTTON(merge_opts->spinbutton_voffs),(gint)(cfile->vsize-mainw->fx6_val)/2);
  }
}




void
on_mspin1_value_changed           (GtkSpinButton   *spinbutton,
				     gpointer         user_data)
{
  // fade start
  mainw->fx4_bool=TRUE;
  mainw->fx1_val=gtk_spin_button_get_value(GTK_SPIN_BUTTON(spinbutton));

  set_pc_end();
}




void
on_mspin2_value_changed           (GtkSpinButton   *spinbutton,
				     gpointer         user_data)
{
  // fade step
  mainw->fx2_val=gtk_spin_button_get_value(GTK_SPIN_BUTTON(spinbutton));
  mainw->fx4_bool=TRUE;

  set_pc_end();
}


void 
set_pc_end (void) {
  if (mainw->fx2_val<0.05&&mainw->fx2_val>-0.05) {
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(merge_opts->spinbutton_pcend),mainw->fx1_val);
  }
  else {
    if (mainw->fx2_val>0.05) {
      gtk_spin_button_set_value(GTK_SPIN_BUTTON(merge_opts->spinbutton_pcend),100.);
      gtk_spin_button_set_range(GTK_SPIN_BUTTON(merge_opts->spinbutton_pcend),mainw->fx1_val,100.);
    }
    else {
      if (mainw->fx2_val<-0.05) {
      gtk_spin_button_set_value(GTK_SPIN_BUTTON(merge_opts->spinbutton_pcend),0.);
      gtk_spin_button_set_range(GTK_SPIN_BUTTON(merge_opts->spinbutton_pcend),0.,mainw->fx1_val);
      }
    }
  }
}






void
on_align_start_end_toggled                (GtkToggleButton *togglebutton,
					   gpointer         user_data)

{
  gint maxextent;
  gint cb_frames=clipboard->frames;
  gboolean ofx4=mainw->fx4_bool;

  align_start=!align_start;

  if (mainw->fx4_bool==FALSE) {

    if (prefs->ins_resample==TRUE&&clipboard->fps!=cfile->fps) {
      if ((cb_frames=(gint) (clipboard->frames/clipboard->fps*cfile->fps+.49999))<1) cb_frames=1;
    }

    if ((maxextent=cfile->end-cfile->start+1)>cb_frames&&loop_to_fit==FALSE) {
      maxextent=cb_frames;
      gtk_spin_button_set_value(GTK_SPIN_BUTTON(merge_opts->spinbutton_pcstart),50);
      gtk_spin_button_set_value(GTK_SPIN_BUTTON(merge_opts->spinbutton_pcstep),0.);
    }
    else {
      maxextent=cfile->end-cfile->start+1;
      if (align_start==TRUE) {
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(merge_opts->spinbutton_pcstart),0);
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(merge_opts->spinbutton_pcstep),100./maxextent);
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(merge_opts->spinbutton_pcend),100.);
      }
      else {
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(merge_opts->spinbutton_pcstart),100);
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(merge_opts->spinbutton_pcstep),-100./maxextent);
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(merge_opts->spinbutton_pcend),0.);
      }
    }
    mainw->fx4_bool=ofx4;
  }
}



void
on_fit_toggled                (GtkToggleButton *togglebutton,
			       gpointer         user_data) {

  gint maxextent;
  gint cb_frames=clipboard->frames;
  gboolean ofx4=mainw->fx4_bool;

  loop_to_fit=!loop_to_fit;
  
  gtk_widget_set_sensitive(merge_opts->spinbutton_loops,!loop_to_fit);

  if (mainw->fx4_bool==FALSE) {
    
    if (prefs->ins_resample==TRUE&&clipboard->fps!=cfile->fps) {
      if ((cb_frames=(gint) (clipboard->frames/clipboard->fps*cfile->fps+.49999))<1) cb_frames=1;
    }

    if ((maxextent=cfile->end-cfile->start+1)>cb_frames&&loop_to_fit==FALSE) {
      maxextent=cb_frames;
      gtk_spin_button_set_value(GTK_SPIN_BUTTON(merge_opts->spinbutton_pcstart),50);
      gtk_spin_button_set_value(GTK_SPIN_BUTTON(merge_opts->spinbutton_pcstep),0.);
    }
    else {
      maxextent=cfile->end-cfile->start+1;
      if (align_start==TRUE) {
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(merge_opts->spinbutton_pcstart),0);
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(merge_opts->spinbutton_pcstep),100./maxextent);
      }
      else {
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(merge_opts->spinbutton_pcstart),100);
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(merge_opts->spinbutton_pcstep),-100./maxextent);
      }
    }
    mainw->fx4_bool=ofx4;
  }
}



void
on_ins_frames_toggled                (GtkToggleButton *togglebutton,
				      gpointer         user_data) 
{
  if (!(cfile->events[EVENT_FRAMES]==NULL)) {
    do_error_dialog("\n\nThis file has frame changes recorded. You must click on Tools|Reorder Frames before you can insert frames.\n\nYou can choose to Undo the reorder afterwards.\n");
    g_signal_handler_block(merge_opts->ins_frame_button,merge_opts->ins_frame_function);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(merge_opts->drop_frame_button),TRUE);
    g_signal_handler_unblock(merge_opts->ins_frame_button,merge_opts->ins_frame_function);
    return;
  }
  ins_frames=!ins_frames;
}
